<?php

/**
 * caco_contrato_entidad actions.
 *
 * @package    cartera
 * @subpackage caco_contrato_entidad
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class caco_contrato_entidadActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    //COMENTARIO DE PRUEBA 20190204

    protected $table_names = array(
        'CACO_CONTRATO_ENTIDAD',
        'CACO_CONTRATO_V',
        'CACO_ENTIDAD_CONTRATO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CACO_CONTRATO_V' =>
        array(
            'id_contrato' => 'CACO_CONTRATO_ENTIDAD'
        ),
        'CACO_ENTIDAD_CONTRATO_V' =>
        array(
            'id_entidad_contrato' => 'CACO_CONTRATO_ENTIDAD'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CACO_CONTRATO_ENTIDAD' =>
        array(
            'id_contrato' => 'id_contrato',
            'id_entidad_contrato' => 'id_entidad_contrato',
            'titular' => 'titular',
            'estado' => 'estado'
        ),
        'CACO_CONTRATO_V' =>
        array(
            'id_tipo_contrato' => 'id_tipo_contrato',
            'descripcion' => 'descripcion',
            'codigo' => 'codigo',
            'id_anhos' => 'id_anhos',
            'codigo_anhos' => 'codigo_anhos',
            'fecha_proceso' => 'fecha_proceso',
            'referencia' => 'referencia',
            'referencia_tipo' => 'referencia_tipo'
        ),
        'CACO_ENTIDAD_CONTRATO_V' =>
        array(
            'id_mae_ter' => 'id_mae_ter',
            'correo_electronico' => 'correo_electronico',
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc',
            'num_doc,||, - ,||,razon_soc' => 'completo'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CACO_CONTRATO_ENTIDAD' => array(
            'id_contrato,a' => array('!=' => array(-1)),
            'id_contrato,b' => array('=' => array('id_contrato')),
            'id_entidad_contrato' => array('=' => array('id_entidad_contrato')),
            'titular' => array('=' => array('titular')),
            'estado' => array('=' => array('estado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //eliminar filas repetivas de consulta sql
    protected $fields_orderBy = array(
        'id_anhos', 'codigo', 'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_contrato'; //identificador de la tabla - solo si es un dato no llave compuesta
    protected $id_names = array('id_contrato', 'id_entidad_contrato'); //llave primaria
    protected $field_names = array('titular', 'estado'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CACO_CONTRATO_ENTIDAD'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * campos para fecha sistema
     */
//    protected $campo_fecha_sistema = array(
//        'fecha_crea'
//    );

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_contrato'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_contrato = $request['id_contrato'];
        $id_entidad_contrato = $request['id_entidad_contrato'];

        /*
         *  Generar errores en $errors
         */
        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM caco_contrato_entidad
where
id_contrato = $id_contrato
and id_entidad_contrato = $id_entidad_contrato 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {
            $errors['mensaje'] = "La entidad ingresada ya existe.";
            $errors['servicio'] = "caco_contrato_entidad";
            $logger->info("La entidad ingresada ya existe.");
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /**
             * Borra titular anterior y crea nuevo caco_contrato_ent - 20190227
             */
            try {

                $id_contrato = $list_data_post[0]['id_contrato'];
                $id_entidad_contrato = $request['id_entidad_contrato'];
                $titular = $request['titular'];

                if ($titular == "true") {
                    $sql = <<<EOD
update caco_contrato_entidad set titular = 0
where
id_contrato = $id_contrato
and id_entidad_contrato != $id_entidad_contrato
and estado = 1               
EOD;
                    $this->conn->execute($sql);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {


                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /**
             * Borra titular anterior y crea nuevo caco_contrato_ent - 20190227
             */
            try {

                $id_contrato = $request['id_contrato'];
                $id_entidad_contrato = $request['id_entidad_contrato'];
                $titular = $request['titular'];

                if ($titular == "true") {
                    $sql = <<<EOD
update caco_contrato_entidad set titular = 0
where
id_contrato = $id_contrato
and id_entidad_contrato != $id_entidad_contrato
and estado = 1               
EOD;
                    $this->conn->execute($sql);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {


                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
